<a id="mypy-boto3-cognito-idp"></a>

# mypy-boto3-cognito-idp

[![PyPI - mypy-boto3-cognito-idp](https://img.shields.io/pypi/v/mypy-boto3-cognito-idp.svg?color=blue)](https://pypi.org/project/mypy-boto3-cognito-idp)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-cognito-idp.svg?color=blue)](https://pypi.org/project/mypy-boto3-cognito-idp)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-cognito-idp?color=blue)](https://pypistats.org/packages/mypy-boto3-cognito-idp)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.CognitoIdentityProvider 1.17.102](https://boto3.amazonaws.com/v1/documentation/api/1.17.102/reference/services/cognito-idp.html#CognitoIdentityProvider)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-buider 4.20.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-cognito-idp docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_cognito_idp/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-cognito-idp](#mypy-boto3-cognito-idp)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

Install `boto3-stubs` for `CognitoIdentityProvider` service.

```bash
python -m pip install boto3-stubs[cognito-idp]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[cognito-idp]` in your environment:
  `python -m pip install 'boto3-stubs[cognito-idp]'`

Both type checking and auto-complete should work for `CognitoIdentityProvider`
service. No explicit type annotations required, write your `boto3` code as
usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto-stubs[cognito-idp]` in your environment:
  `python -m pip install 'boto3-stubs[cognito-idp]'`

Both type checking and auto-complete should work for `CognitoIdentityProvider`
service. No explicit type annotations required, write your `boto3` code as
usual. Auto-complete can be slow on big projects or if you have a lot of
installed `boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[cognito-idp]` in your environment:
  `python -m pip install 'boto3-stubs[cognito-idp]'`
- Run `mypy` as usual

Type checking should work for `CognitoIdentityProvider` service. No explicit
type annotations required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[cognito-idp]` in your environment:
  `python -m pip install 'boto3-stubs[cognito-idp]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `CognitoIdentityProvider` service. No explicit
type annotations required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`CognitoIdentityProviderClient` provides annotations for
`boto3.client("cognito-idp")`.

```python
import boto3

from mypy_boto3_cognito_idp import CognitoIdentityProviderClient

client: CognitoIdentityProviderClient = boto3.client("cognito-idp")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: CognitoIdentityProviderClient = session.client("cognito-idp")
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_cognito_idp.paginator` module contains type annotations for all
paginators.

```python
from mypy_boto3_cognito_idp import CognitoIdentityProviderClient
from mypy_boto3_cognito_idp.paginator import (
    AdminListGroupsForUserPaginator,
    AdminListUserAuthEventsPaginator,
    ListGroupsPaginator,
    ListIdentityProvidersPaginator,
    ListResourceServersPaginator,
    ListUserPoolClientsPaginator,
    ListUserPoolsPaginator,
    ListUsersPaginator,
    ListUsersInGroupPaginator,
)

client: CognitoIdentityProviderClient = boto3.client("cognito-idp")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
admin_list_groups_for_user_paginator: AdminListGroupsForUserPaginator = client.get_paginator("admin_list_groups_for_user")
admin_list_user_auth_events_paginator: AdminListUserAuthEventsPaginator = client.get_paginator("admin_list_user_auth_events")
list_groups_paginator: ListGroupsPaginator = client.get_paginator("list_groups")
list_identity_providers_paginator: ListIdentityProvidersPaginator = client.get_paginator("list_identity_providers")
list_resource_servers_paginator: ListResourceServersPaginator = client.get_paginator("list_resource_servers")
list_user_pool_clients_paginator: ListUserPoolClientsPaginator = client.get_paginator("list_user_pool_clients")
list_user_pools_paginator: ListUserPoolsPaginator = client.get_paginator("list_user_pools")
list_users_paginator: ListUsersPaginator = client.get_paginator("list_users")
list_users_in_group_paginator: ListUsersInGroupPaginator = client.get_paginator("list_users_in_group")
```

<a id="literals"></a>

### Literals

`mypy_boto3_cognito_idp.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from mypy_boto3_cognito_idp.literals import (
    AccountTakeoverEventActionTypeType,
    AdminListGroupsForUserPaginatorName,
    AdminListUserAuthEventsPaginatorName,
    AdvancedSecurityModeTypeType,
    AliasAttributeTypeType,
    AttributeDataTypeType,
    AuthFlowTypeType,
    ChallengeNameType,
    ChallengeNameTypeType,
    ChallengeResponseType,
    CompromisedCredentialsEventActionTypeType,
    CustomEmailSenderLambdaVersionTypeType,
    CustomSMSSenderLambdaVersionTypeType,
    DefaultEmailOptionTypeType,
    DeliveryMediumTypeType,
    DeviceRememberedStatusTypeType,
    DomainStatusTypeType,
    EmailSendingAccountTypeType,
    EventFilterTypeType,
    EventResponseTypeType,
    EventTypeType,
    ExplicitAuthFlowsTypeType,
    FeedbackValueTypeType,
    IdentityProviderTypeTypeType,
    ListGroupsPaginatorName,
    ListIdentityProvidersPaginatorName,
    ListResourceServersPaginatorName,
    ListUserPoolClientsPaginatorName,
    ListUserPoolsPaginatorName,
    ListUsersInGroupPaginatorName,
    ListUsersPaginatorName,
    MessageActionTypeType,
    OAuthFlowTypeType,
    PreventUserExistenceErrorTypesType,
    RecoveryOptionNameTypeType,
    RiskDecisionTypeType,
    RiskLevelTypeType,
    StatusTypeType,
    TimeUnitsTypeType,
    UserImportJobStatusTypeType,
    UserPoolMfaTypeType,
    UserStatusTypeType,
    UsernameAttributeTypeType,
    VerifiedAttributeTypeType,
    VerifySoftwareTokenResponseTypeType,
)

def check_value(value: AccountTakeoverEventActionTypeType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_cognito_idp.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_cognito_idp.type_defs import (
    AccountRecoverySettingTypeTypeDef,
    AccountTakeoverActionTypeTypeDef,
    AccountTakeoverActionsTypeTypeDef,
    AccountTakeoverRiskConfigurationTypeTypeDef,
    AddCustomAttributesRequestTypeDef,
    AdminAddUserToGroupRequestTypeDef,
    AdminConfirmSignUpRequestTypeDef,
    AdminCreateUserConfigTypeTypeDef,
    AdminCreateUserRequestTypeDef,
    AdminCreateUserResponseResponseTypeDef,
    AdminDeleteUserAttributesRequestTypeDef,
    AdminDeleteUserRequestTypeDef,
    AdminDisableProviderForUserRequestTypeDef,
    AdminDisableUserRequestTypeDef,
    AdminEnableUserRequestTypeDef,
    AdminForgetDeviceRequestTypeDef,
    AdminGetDeviceRequestTypeDef,
    AdminGetDeviceResponseResponseTypeDef,
    AdminGetUserRequestTypeDef,
    AdminGetUserResponseResponseTypeDef,
    AdminInitiateAuthRequestTypeDef,
    AdminInitiateAuthResponseResponseTypeDef,
    AdminLinkProviderForUserRequestTypeDef,
    AdminListDevicesRequestTypeDef,
    AdminListDevicesResponseResponseTypeDef,
    AdminListGroupsForUserRequestTypeDef,
    AdminListGroupsForUserResponseResponseTypeDef,
    AdminListUserAuthEventsRequestTypeDef,
    AdminListUserAuthEventsResponseResponseTypeDef,
    AdminRemoveUserFromGroupRequestTypeDef,
    AdminResetUserPasswordRequestTypeDef,
    AdminRespondToAuthChallengeRequestTypeDef,
    AdminRespondToAuthChallengeResponseResponseTypeDef,
    AdminSetUserMFAPreferenceRequestTypeDef,
    AdminSetUserPasswordRequestTypeDef,
    AdminSetUserSettingsRequestTypeDef,
    AdminUpdateAuthEventFeedbackRequestTypeDef,
    AdminUpdateDeviceStatusRequestTypeDef,
    AdminUpdateUserAttributesRequestTypeDef,
    AdminUserGlobalSignOutRequestTypeDef,
    AnalyticsConfigurationTypeTypeDef,
    AnalyticsMetadataTypeTypeDef,
    AssociateSoftwareTokenRequestTypeDef,
    AssociateSoftwareTokenResponseResponseTypeDef,
    AttributeTypeTypeDef,
    AuthEventTypeTypeDef,
    AuthenticationResultTypeTypeDef,
    ChallengeResponseTypeTypeDef,
    ChangePasswordRequestTypeDef,
    CodeDeliveryDetailsTypeTypeDef,
    CompromisedCredentialsActionsTypeTypeDef,
    CompromisedCredentialsRiskConfigurationTypeTypeDef,
    ConfirmDeviceRequestTypeDef,
    ConfirmDeviceResponseResponseTypeDef,
    ConfirmForgotPasswordRequestTypeDef,
    ConfirmSignUpRequestTypeDef,
    ContextDataTypeTypeDef,
    CreateGroupRequestTypeDef,
    CreateGroupResponseResponseTypeDef,
    CreateIdentityProviderRequestTypeDef,
    CreateIdentityProviderResponseResponseTypeDef,
    CreateResourceServerRequestTypeDef,
    CreateResourceServerResponseResponseTypeDef,
    CreateUserImportJobRequestTypeDef,
    CreateUserImportJobResponseResponseTypeDef,
    CreateUserPoolClientRequestTypeDef,
    CreateUserPoolClientResponseResponseTypeDef,
    CreateUserPoolDomainRequestTypeDef,
    CreateUserPoolDomainResponseResponseTypeDef,
    CreateUserPoolRequestTypeDef,
    CreateUserPoolResponseResponseTypeDef,
    CustomDomainConfigTypeTypeDef,
    CustomEmailLambdaVersionConfigTypeTypeDef,
    CustomSMSLambdaVersionConfigTypeTypeDef,
    DeleteGroupRequestTypeDef,
    DeleteIdentityProviderRequestTypeDef,
    DeleteResourceServerRequestTypeDef,
    DeleteUserAttributesRequestTypeDef,
    DeleteUserPoolClientRequestTypeDef,
    DeleteUserPoolDomainRequestTypeDef,
    DeleteUserPoolRequestTypeDef,
    DeleteUserRequestTypeDef,
    DescribeIdentityProviderRequestTypeDef,
    DescribeIdentityProviderResponseResponseTypeDef,
    DescribeResourceServerRequestTypeDef,
    DescribeResourceServerResponseResponseTypeDef,
    DescribeRiskConfigurationRequestTypeDef,
    DescribeRiskConfigurationResponseResponseTypeDef,
    DescribeUserImportJobRequestTypeDef,
    DescribeUserImportJobResponseResponseTypeDef,
    DescribeUserPoolClientRequestTypeDef,
    DescribeUserPoolClientResponseResponseTypeDef,
    DescribeUserPoolDomainRequestTypeDef,
    DescribeUserPoolDomainResponseResponseTypeDef,
    DescribeUserPoolRequestTypeDef,
    DescribeUserPoolResponseResponseTypeDef,
    DeviceConfigurationTypeTypeDef,
    DeviceSecretVerifierConfigTypeTypeDef,
    DeviceTypeTypeDef,
    DomainDescriptionTypeTypeDef,
    EmailConfigurationTypeTypeDef,
    EventContextDataTypeTypeDef,
    EventFeedbackTypeTypeDef,
    EventRiskTypeTypeDef,
    ForgetDeviceRequestTypeDef,
    ForgotPasswordRequestTypeDef,
    ForgotPasswordResponseResponseTypeDef,
    GetCSVHeaderRequestTypeDef,
    GetCSVHeaderResponseResponseTypeDef,
    GetDeviceRequestTypeDef,
    GetDeviceResponseResponseTypeDef,
    GetGroupRequestTypeDef,
    GetGroupResponseResponseTypeDef,
    GetIdentityProviderByIdentifierRequestTypeDef,
    GetIdentityProviderByIdentifierResponseResponseTypeDef,
    GetSigningCertificateRequestTypeDef,
    GetSigningCertificateResponseResponseTypeDef,
    GetUICustomizationRequestTypeDef,
    GetUICustomizationResponseResponseTypeDef,
    GetUserAttributeVerificationCodeRequestTypeDef,
    GetUserAttributeVerificationCodeResponseResponseTypeDef,
    GetUserPoolMfaConfigRequestTypeDef,
    GetUserPoolMfaConfigResponseResponseTypeDef,
    GetUserRequestTypeDef,
    GetUserResponseResponseTypeDef,
    GlobalSignOutRequestTypeDef,
    GroupTypeTypeDef,
    HttpHeaderTypeDef,
    IdentityProviderTypeTypeDef,
    InitiateAuthRequestTypeDef,
    InitiateAuthResponseResponseTypeDef,
    LambdaConfigTypeTypeDef,
    ListDevicesRequestTypeDef,
    ListDevicesResponseResponseTypeDef,
    ListGroupsRequestTypeDef,
    ListGroupsResponseResponseTypeDef,
    ListIdentityProvidersRequestTypeDef,
    ListIdentityProvidersResponseResponseTypeDef,
    ListResourceServersRequestTypeDef,
    ListResourceServersResponseResponseTypeDef,
    ListTagsForResourceRequestTypeDef,
    ListTagsForResourceResponseResponseTypeDef,
    ListUserImportJobsRequestTypeDef,
    ListUserImportJobsResponseResponseTypeDef,
    ListUserPoolClientsRequestTypeDef,
    ListUserPoolClientsResponseResponseTypeDef,
    ListUserPoolsRequestTypeDef,
    ListUserPoolsResponseResponseTypeDef,
    ListUsersInGroupRequestTypeDef,
    ListUsersInGroupResponseResponseTypeDef,
    ListUsersRequestTypeDef,
    ListUsersResponseResponseTypeDef,
    MFAOptionTypeTypeDef,
    MessageTemplateTypeTypeDef,
    NewDeviceMetadataTypeTypeDef,
    NotifyConfigurationTypeTypeDef,
    NotifyEmailTypeTypeDef,
    NumberAttributeConstraintsTypeTypeDef,
    PaginatorConfigTypeDef,
    PasswordPolicyTypeTypeDef,
    ProviderDescriptionTypeDef,
    ProviderUserIdentifierTypeTypeDef,
    RecoveryOptionTypeTypeDef,
    ResendConfirmationCodeRequestTypeDef,
    ResendConfirmationCodeResponseResponseTypeDef,
    ResourceServerScopeTypeTypeDef,
    ResourceServerTypeTypeDef,
    RespondToAuthChallengeRequestTypeDef,
    RespondToAuthChallengeResponseResponseTypeDef,
    ResponseMetadataTypeDef,
    RevokeTokenRequestTypeDef,
    RiskConfigurationTypeTypeDef,
    RiskExceptionConfigurationTypeTypeDef,
    SMSMfaSettingsTypeTypeDef,
    SchemaAttributeTypeTypeDef,
    SetRiskConfigurationRequestTypeDef,
    SetRiskConfigurationResponseResponseTypeDef,
    SetUICustomizationRequestTypeDef,
    SetUICustomizationResponseResponseTypeDef,
    SetUserMFAPreferenceRequestTypeDef,
    SetUserPoolMfaConfigRequestTypeDef,
    SetUserPoolMfaConfigResponseResponseTypeDef,
    SetUserSettingsRequestTypeDef,
    SignUpRequestTypeDef,
    SignUpResponseResponseTypeDef,
    SmsConfigurationTypeTypeDef,
    SmsMfaConfigTypeTypeDef,
    SoftwareTokenMfaConfigTypeTypeDef,
    SoftwareTokenMfaSettingsTypeTypeDef,
    StartUserImportJobRequestTypeDef,
    StartUserImportJobResponseResponseTypeDef,
    StopUserImportJobRequestTypeDef,
    StopUserImportJobResponseResponseTypeDef,
    StringAttributeConstraintsTypeTypeDef,
    TagResourceRequestTypeDef,
    TokenValidityUnitsTypeTypeDef,
    UICustomizationTypeTypeDef,
    UntagResourceRequestTypeDef,
    UpdateAuthEventFeedbackRequestTypeDef,
    UpdateDeviceStatusRequestTypeDef,
    UpdateGroupRequestTypeDef,
    UpdateGroupResponseResponseTypeDef,
    UpdateIdentityProviderRequestTypeDef,
    UpdateIdentityProviderResponseResponseTypeDef,
    UpdateResourceServerRequestTypeDef,
    UpdateResourceServerResponseResponseTypeDef,
    UpdateUserAttributesRequestTypeDef,
    UpdateUserAttributesResponseResponseTypeDef,
    UpdateUserPoolClientRequestTypeDef,
    UpdateUserPoolClientResponseResponseTypeDef,
    UpdateUserPoolDomainRequestTypeDef,
    UpdateUserPoolDomainResponseResponseTypeDef,
    UpdateUserPoolRequestTypeDef,
    UserContextDataTypeTypeDef,
    UserImportJobTypeTypeDef,
    UserPoolAddOnsTypeTypeDef,
    UserPoolClientDescriptionTypeDef,
    UserPoolClientTypeTypeDef,
    UserPoolDescriptionTypeTypeDef,
    UserPoolPolicyTypeTypeDef,
    UserPoolTypeTypeDef,
    UserTypeTypeDef,
    UsernameConfigurationTypeTypeDef,
    VerificationMessageTemplateTypeTypeDef,
    VerifySoftwareTokenRequestTypeDef,
    VerifySoftwareTokenResponseResponseTypeDef,
    VerifyUserAttributeRequestTypeDef,
)

def get_structure() -> AccountRecoverySettingTypeTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-cognito-idp` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-cognito-idp docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_cognito_idp/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
